/// <reference types="node" />
import { DomainEventMessage } from 'cm-schema-event';
import { DomainSchema } from './domain-schema';
import { DomainEventCodec } from './domain-event-codec';
import { BdkSet } from './domain-event-cipher';
export { DomainEventMessage };
export declare class DomainEvent<T, M> {
    protected codec: DomainEventCodec<Buffer, Buffer>;
    protected schema: DomainSchema<T>;
    protected metadataSchema: DomainSchema<M>;
    constructor(schemaName: string, schema: string, metadataSchema?: string);
    encode({ eventType, eventId, correlationId, correlationTopic, timestamp, body, metadata }: DomainEventMessage<T, M>): Buffer;
    decode(encodedMessage: Buffer): DomainEventMessage<T, M>;
    static init(bdkSet: BdkSet, ksn: Buffer): void;
}
